import { upImgPathConfig } from "../serverConfig";
import { BizError } from "./bizError";
import { logError } from "./log";

var PSD = require('node-psd');
const path = require('path');
/**
 * psdForPng  psd转png
 * @param fileName psd文件名称，记得不带.psd
 */
export async function psdForPng(fileName:string) {
    fileName = "1213"
    const psdName = fileName+".psd";
    const pngName = fileName+".png";


    let filePath = path.join(__dirname.substring(0,__dirname.indexOf("out")), upImgPathConfig.psd, psdName);
    let pngFilePath =  path.join(__dirname.substring(0,__dirname.indexOf("out")), upImgPathConfig.png, pngName);
    
    try {
        let thisPsd = PSD.fromFile(filePath);
        thisPsd.parse()
        thisPsd.image.toPng();
        PSD.open(filePath).then(function (psd) {
            psd.image.saveAsPng(pngFilePath);
        });
    } catch(err) {
        throw new BizError(psdName, "转png失败", err.message  || err.msg);
    }
}